#!/usr/bin/env python
import imp
import inspect
import os
import site
# me
from public import public


def _listdirs(path):
    return list(filter(
        lambda i: os.path.isdir(i),
        map(
            lambda name: os.path.join(path, name),
            os.listdir(path)
        )
    ))


def _listfiles(path):
    return list(filter(
        lambda i: os.path.isfile(i),
        map(
            lambda name: os.path.join(path, name),
            os.listdir(path)
        )
    ))


def _find_file(name):
    files = []
    for sp in site.getsitepackages():
        if os.path.exists(sp):
            files += os.listdir(sp)
    modules = filter(
        lambda f: os.path.splitext(f) == ".py" and os.path.isfile(f),
        files
    )
    for m in modules:
        if m.name.lower() == name.lower():
            return m.name


def _find_dir(name):
    name = name.lower()
    packages = []
    for sp in site.getsitepackages():
        if os.path.exists(sp):
            packages += _listdirs(sp)
    for pkg in sorted(packages):
        if os.path.basename(pkg.lower()).find(name) == 0:
            return os.path.basename(pkg)[0:len(name)]


def _find_module(name, path=None):
    try:
        # (file, filename, (suffix, mode, type)) = imp.find_module(name, path)
        return imp.find_module(name, path)
    except ImportError:
        pass


@public
def find_module(fullname, path=None):
    """todo"""
    module = inspect.getmodule(fullname)
    if module:  # module.object
        fullname = module
    if inspect.ismodule(fullname):
        if hasattr(module, "__file__"):
            fullname = fullname.__name__
            # __file__ = module.__file__
            # if file.name(__file__)=="__init__":
            # # package
            # return dirname(__file__)
            # return __file__
        else:  # in-memory module
            return
    names = fullname.split('.')
    for i, name in enumerate(names):
        # check AS IS case sensitive
        # print("name = %s" % name)
        t = _find_module(name, path)
        if not t:
            # try lowercase
            t = _find_module(name.lower(), path)
        if not t:
            return
        if i == 0:
            if not t:
                # search filename.py(c)
                file = _find_file(name)
                if not file:
                    return
                t = _find_module(file)
            if not t:
                # search package/
                folder = _find_dir(name)
                if not folder:
                    return
                t = _find_module(folder)
        if t:
            if t[1] is None:
                return ""  # memory module
            filename = t[1]
            if path and filename.find(path[0]) < 0:
                # get parent module with same name
                break
            # sysname = ".".join(names[0:i + 1]).lower()
            path = [filename]
            # path=tolist(path)+[dirname(filename)]
        # t = None
        if not t:
            return
    return filename
